# Analyse lexicale

## Les modules

- `common.ml` contient la déclaration des tokens (unités lexicales) et la fonction `main` qui fait appel à un analyseur lexical (argument `get_token`) pour lire un pas un les tokens contenus dans un stream (argument `src`).

- `hand.ml` contient un analyseur lexical fonctionnel écrit manuellement (la fonction `token`) et l'appel à la fonction `Common.main` avec cet analyseur et comme stream le premier argument en ligne de commande.

- `auto.ml` contient un analyseur lexical sous forme d'automate (la fonction `token`) avec une table de transitions (la variable `transitions`) remplie manuellement, et l'appel à la fonction `Common.main` avec cet analyseur et comme stream le premier argument en ligne de commande.

- `lexer.mll` contient la description d'un analyseur lexical pour l'outil `ocamllex`, et l'appel à la fonction `Common.main` avec cet analyseur et comme stream le premier argument en ligne de commande.

## Compilation

- Pour tout (re)compiler d'un coup : `dune build` qui produira les exécutables `hand.exe`, `auto.exe`, et `lexer.exe`.

- Chacun de ces exécutables peut être (re)compilé indépendamment avec `dune build <nom.exe>`.

- La commande `dune clean` permet de nettoyer le dossier de l'ensemble des artefacts de compilation.
